<script setup>
  import UserSection from '../components/UserSection.vue'
  import NavBar from '../components/NavBar.vue'
  import { ref, onMounted, inject } from 'vue'
  import { useRoute  } from 'vue-router'
  const axios = inject('axios')
  const dayjs = inject('dayjs')  // inject axios
  const route = useRoute()
  const reservations = ref([])
  const tempReservations = ref([])
  const historyReservation = ref(false)

  onMounted(() => {
    axios.get(`${localStorage.getItem("username")}/reservations/${localStorage.getItem("jwt")}`)
    .then(function(response){
        if(response.status===200){
          reservations.value = response.data
          tempReservations.value= reservations.value.filter((reservation)=>dayjs().isBefore(dayjs(reservation.start_time)))
        }
    });
      

  });


  function deleteReservation(reservationId){
    axios.delete(`${localStorage.getItem("username")}/reservations/${reservationId}/${localStorage.getItem("jwt")}`).then(function(response){
      if(response.status===200){
        axios.get(`${localStorage.getItem("username")}/reservations/${localStorage.getItem("jwt")}`)
            .then(function(response){
        if(response.status===200){
          reservations.value = response.data
          tempReservations.value= reservations.value.filter((reservation)=>dayjs().isBefore(dayjs(reservation.start_time)))
        }
    })
      }
    })
  }



  function onToggleHistory() {
    historyReservation.value = !historyReservation.value
      if(historyReservation.value){
        tempReservations.value= reservations.value.filter((reservation)=>dayjs().isAfter(dayjs(reservation.start_time)))
      }else{
        tempReservations.value= reservations.value.filter((reservation)=>dayjs().isBefore(dayjs(reservation.start_time)))
      }
    }
</script>


<template>
  <NavBar></NavBar>
    <header class="bg-slate-50">
    <div class="mx-auto max-w-7xl px-4 py-6 sm:px-6 lg:px-8">
      <h1 class="text-3xl font-bold tracking-tight text-gray-900 text-center">Reservations</h1>
    </div>
  </header>
  <main class="grid grid-flow-col gap-4 grid-cols-[min-content_1fr]">
    <aside class="z-40 h-full bg-slate-100 dark:bg-gray-800">
        <UserSection/>
      </aside>
      <div>
        <div>
          <ul class="flex flex-wrap text-sm font-medium text-center text-gray-500 dark:text-gray-400 pt-4 px-8">
            <li class="me-2">
                <a
                @click="onToggleHistory"
                :class="{'bg-blue-600 active text-white': !historyReservation, 
                            'hover:text-gray-900 hover:bg-gray-100':historyReservation}"
                            
                class="inline-block px-4 py-3 rounded-lg ">Upcoming</a>
            </li>
            <li class="me-2"
            >
                <a 
                @click="onToggleHistory"
                :class="{'bg-blue-600 active text-white': historyReservation, 
                            'hover:text-gray-900 hover:bg-gray-100':!historyReservation}"
                class="inline-block px-4 py-3 rounded-lg ">History</a>
            </li>
          </ul>
        </div>
        <div class="py-4 px-8">
          <table v-if="reservations.length" class="w-full text-sm text-left rtl:text-right text-gray-500 dark:text-gray-400">
            <thead class="text-xs text-gray-700 uppercase bg-gray-50 dark:bg-gray-700 dark:text-gray-400">
                <tr>
                    <th scope="col" class="px-6 py-3">
                        Lection Name
                    </th>
                    <th scope="col" class="px-6 py-3">
                        Lection Description
                    </th>
                    <th scope="col" class="px-6 py-3">
                        Room
                    </th>
                    <th scope="col" class="px-6 py-3">
                        Trainer
                    </th>
                    <th scope="col" class="px-6 py-3">
                        Date and Time
                    </th>
                    <th scope="col" class="px-6 py-3">
                        Edit
                    </th>
                </tr>
            </thead>
            <tbody>
            <tr v-for="reservation in tempReservations"
            
            class="bg-white border-b">
                <th scope="row" class="flex items-center px-6 py-4 text-gray-900 whitespace-nowrap dark:text-white">
                    <div class="ps-3">
                        <div class="text-base font-semibold ">{{reservation.name}}</div>
                    </div>  
                </th>
                <td class="px-6 py-4 ">
                    {{reservation.description}}
                </td>
                <td class="px-6 py-4">
                    <div class="flex items-center">
                        {{reservation.room_name}}
                    </div>
                </td>
                <td class="px-6 py-4">
                    {{ reservation.trainer_name}}
                </td>
                <td class="px-6 py-4">
                  <p class="font-semibold">
                    {{ dayjs(reservation.start_time).format('DD.MM.YYYY')}}
                  </p>
                  <p>
                    {{dayjs(reservation.start_time).format('H:mm') + ' - ' + dayjs(reservation.end_time).format('H:mm')  }}
                  </p>
                </td>
                <td class="px-6 py-4">
                  <button 
                  @click="deleteReservation(reservation.id)"
                  :class="{'bg-gray-100 fill-gray-600':historyReservation,
                            'fill-rose-600 hover:fill-rose-800 hover:bg-rose-200' : !historyReservation}"
                  :disabled="historyReservation"
                  class="p-2 w-8 h-8 rounded-md">
                    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512">
                    <path d="M170.5 51.6L151.5 80h145l-19-28.4c-1.5-2.2-4-3.6-6.7-3.6H177.1c-2.7 0-5.2 1.3-6.7 3.6zm147-26.6L354.2 80H368h48 8c13.3 0 24 10.7 24 24s-10.7 24-24 24h-8V432c0 44.2-35.8 80-80 80H112c-44.2 0-80-35.8-80-80V128H24c-13.3 0-24-10.7-24-24S10.7 80 24 80h8H80 93.8l36.7-55.1C140.9 9.4 158.4 0 177.1 0h93.7c18.7 0 36.2 9.4 46.6 24.9zM80 128V432c0 17.7 14.3 32 32 32H336c17.7 0 32-14.3 32-32V128H80zm80 64V400c0 8.8-7.2 16-16 16s-16-7.2-16-16V192c0-8.8 7.2-16 16-16s16 7.2 16 16zm80 0V400c0 8.8-7.2 16-16 16s-16-7.2-16-16V192c0-8.8 7.2-16 16-16s16 7.2 16 16zm80 0V400c0 8.8-7.2 16-16 16s-16-7.2-16-16V192c0-8.8 7.2-16 16-16s16 7.2 16 16z"/>
                  </svg>
                  </button>
                </td>
            </tr>
        </tbody>
          </table>
          <div v-if="!reservations.length" class="p-4 my-4 text-sm text-yellow-800 rounded-lg bg-yellow-50">
            <span class="font-medium">Info </span> You have no reservation. Please create one.
        </div>
        </div>
      </div> 
  </main>
</template>